/*
 * Main.java
 *
 * Created on 27 April 2006, 21:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package camelgame;

/**
 *
 * @author Daniel
 */

//Declaring the variable types
public class Camel {
    private String OutputStr;
    int distance_travelled;
    int commands_left;
    int drinks_left;
    int camel_strength;
    int turns;
    int ots_distance;
    int i;

//Assigning values to the variables
public Camel()
{
    distance_travelled = 0;
    commands_left = 4;
    drinks_left = 6;
    camel_strength = 0;
    turns = 0;
    ots_distance = 0;
    OutputStr = "";
}
 public static void camelgame(String[] args) {
 }

//The drinking process
 public String processDrink( )
{
    drinks_left --;
    if (drinks_left < 0)
        out_of_water();/*If there is drinks_water is less than 0, the out_of_water process is run*/
    else
    {
        OutputStr += "\nBetter watch for an oasis.";
        commands_left = 4;
        next_step();/*Otherwise commands are reset and the game proceeds*/
    }
    return (OutputStr);
}

//The moderate speed process
public String processModerate( )
{
    camel_strength ++;
    if (camel_strength>7)
        camel_died();/*If camel_strength exceeds 7, the camel_died process is run*/
    else
    {
        any_adventures();
        distance_travelled += (int)(Math.random()*10)+1;
        OutputStr += "\nYour camel likes this pace..";
        next_step();/*Otherwise the any_adventures process is run, the distance is increased and the game proceeds*/
    }
    return (OutputStr);
}

//The full speed process
public String processFull( )
{
    camel_strength += 3;
    if (camel_strength>7)
        camel_died();/*If camel_strength exceeds 7, the camel_died process is run*/
    else
    {
        any_adventures();
        distance_travelled = 2*((int)(Math.random()*10))+1;
        OutputStr += "\nYour camel is burning across the desert ";
        OutputStr += "sands...";
        next_step();/*Otherwise the any_adventures process is run, the distance is increased and the game proceeds*/
    }
    return (OutputStr);
}

//The stop process
public String processStop( )
{
    OutputStr += "\nYour camel thanks you!";
    camel_strength = 0;
    next_step();/*camel_strength is reset and the game proceeds*/
    return (OutputStr);
}

//The status process
public String processStatus( )
{
    OutputStr += "\nYour camel has "+camel_strength+" good days left.\n";
    OutputStr += "You have "+drinks_left+" in your canteen.\n";
    OutputStr += "You can go "+commands_left+" without drinking.";
    next_step();/*The status is shown and the game proceeds*/
    return (OutputStr);
}

//The hope process
public String processHope( )
{
    i = (int)(Math.random()*10) + 1;
    if (i != 1)
    {
        gonegone();/*If 'i' is not 1 the gonegone process is run*/
    }
    else
    {
        OutputStr += "\nHelp has found you in a state of unconsciousness,.";
        drinks_left = 3;
        commands_left = 4;
        next_step();/*Otherwise the variables are altered and the game proceeds*/
    }
    return (OutputStr);
}

//The dead camel process
public String camel_died()
{
    OutputStr += "\nYou dirty rapscallion! You ran ";
    OutputStr += "your poor camel to death!!";
    gonegone();/*The text is displayed and the gonegone process is run*/
    return (OutputStr);
}

//The out of water process
public String out_of_water()
{
    OutputStr += "\nYou ran out of water.....Sorry chum!!!!";
    gonegone();/*The text is displayed and the gonegone process is run*/
    return (OutputStr);
}

//The adventure process
public String any_adventures ()
{
    i = (int)(Math.random()*100);
    if (i < 20)
        found_oasis();/*If the number is less than 20 the found_oasis process is run*/
    else
    {
        if (i < 50)
            found_sandstorm();/*If the number is less than 50 the found_sandstorm process is run*/
        else
        {
            if (i < 75)
            {
                ots_distance ++;
                OutputStr += "\nYour camel hurt his hump.";
                OutputStr += "Luckily, the OTS were ";
                OutputStr += "footweary!!";/*If the number is less than 75 ots_distance is increased*/
            }
        }
    }
    return (OutputStr);
}

//The oasis process
public String found_oasis()
{
    OutputStr += "\nYou have arrived at an oasis. ";
    OutputStr += "Your camel is ";
    OutputStr += "filling your canteen and eating figs.";
    commands_left = 4;
    drinks_left = 6;/*Variables altered and the game proceeds*/
    return (OutputStr);
}

//The sandstorm process
public String found_sandstorm()
{
    OutputStr += "\nYou have been caught in a sandstorm ";
    OutputStr += "....Good luck!.";
    int x5 = (int)(Math.random()*10)+1;
    int x6 = (int)(Math.random()*10);/*The variables for the calculation are decided*/
    if (x6 < 5)
        distance_travelled += x5;/*If the value is less than 5, increase distance_travelled and proceed*/
    else
        distance_travelled -= x5;/*Otherwise decrease distance_travelled and proceed*/
    OutputStr += "\nYour new position is "+distance_travelled+" miles so far!";
    return (OutputStr);
}

//The new game process
public String processNew( )
{   OutputStr = "";
    OutputStr += "Welcome to Camel.\n";
    OutputStr += "The object is to travel 200 miles across the\n";
    OutputStr += "Gobi Desert to reach the authorities. A group of outlaw treasure seekers\n";
    OutputStr += "(OTS, for short) will be chasing you and will prevent you from\n";
    OutputStr += "seeingcivilization again. You have a 4-command head start. You will\n";
    OutputStr += "click on the buttons for your commands. You have one quart of water,\n";
    OutputStr += "which will last you six drinks. You can renew your water supply\n";
    OutputStr += "completely at an oasis You get a half a quart if found by help. If help\n";
    OutputStr += "does not find you after hoping for help, you lose. Good luck and good\n";
    OutputStr += "cameling!! You are in the middle of the desert at an oasis...\n";
    start_over();/*Display text then run the start_over process*/
    return (OutputStr);
}

//The clear screen process
public String clearScreen()
{
    OutputStr = "";/*Removes all the text in OutputStr*/
    return (OutputStr);
}

//The next step process
public String next_step()
{
    if (distance_travelled > 199)
    {
        OutputStr += "\nYou reached civilization!!!";
        OutputStr += "A party is being given in your honor";/*If you have reached 200 miles, you win*/
    }
    else
    {
        commands_left --;
        turns ++;/*Decrease commands and increase turns*/
        if (commands_left <= 1)
        {
           OutputStr += "\n----WARNING-----Get a drink.";/*If commands_left <= 1 display text*/
        }
        else
        {
            if (commands_left < 0)
            out_of_water();/*If there are no commands remaining, run the out_of_water process*/
            else
            {
                OutputStr += "\nYou have traveled "+distance_travelled+" miles altogether.";/*Other display text*/
                if (turns > 4)
                {
                    i = (int)((10*Math.random())+2.5);
                    ots_distance += i;/*If turns are less than 4, increase ots_distance by i*/
                    if (ots_distance > distance_travelled)
                    {
                        OutputStr += "\nThe OTS have captured you.";
                        OutputStr += "Camel soup is their ";
                        OutputStr += "favorite dish...";
                        start_over();/*Display text run the start_over process*/
                    }
                    else
                    {
                        int behind = distance_travelled-ots_distance;
                        OutputStr += "\nThe OTS are "+behind+" miles behind you..\n";/*Otherwise calculate behind and display text*/
                    }
                }
            }
        
        }
    }
OutputStr += "\n";/*This section of code will help break the text to make it easier to read*/
return (OutputStr);}

//The gonegone process
public String gonegone()
{
    OutputStr += "\nYou died in the desert..";
    i = (int)(Math.random()*5)+1;/*Display text and calculate i*/
    switch (i)/*Display the case according to the value of i*/
    {
    case 1:
    OutputStr += "\nThe National Camel's Union ";
    OutputStr += "is not attending your funeral!!!.";
    break;
    case 2:
    OutputStr += "\nYour body was eaten by vultures.!!!.";
    break;
    case 3:
    OutputStr += "\nThe chief of the OTS now uses your ";
    OutputStr += "skull for a change purse!!!.";
    break;
    case 4:
    OutputStr += "\nPeople with little intelligence ";
    OutputStr += "Don't mix well with deserts.";
    break;
    case 5:
    OutputStr += "\nTurkeys should fly, not ride ";
    OutputStr += "camels!!!.";
    break;
    }
    OutputStr += "\nThat's all!!.";
    start_over();
    return (OutputStr);
}

//The startover process
public String start_over()
{
    distance_travelled = 0;
    commands_left = 4;
    drinks_left = 6;
    camel_strength = 0;
    turns = 0;
    ots_distance = 0;/*Assign these values to the variables*/
    return (OutputStr);
}

}
